package uk.co.sculptor.demos.stockcontrol;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * Created on 3 June 2015
 *
 * @author Sculptor Ltd.
 */
public class StockControl {
	/**
	 * An array of Products on Stock
	 */
	private static List<Product> g_stockList = new ArrayList<Product>();

	/*
	 * A Map to relate each Product with it's Product.m_ItemCode
	 */
	private static Map<String, Product> g_stockMap = new HashMap<String, Product>();

	static {
		resetStock();
		// Add a Product with description "Loading"
		addProduct(new Product("", 0, 0, 0, 0, 0, 0, "", (short) 0, "", "Loading"));
	}

	public static void addProduct(Product product) {
		g_stockList.add(product);
		g_stockMap.put(product.getItemCode(), product);
	}

	public static void resetStock() {
		// Clear the List & Map
		g_stockList.clear();
		g_stockMap.clear();
	}

	public static void replaceStock(List<Product> list) {
		resetStock();

		for (Iterator<Product> i = list.iterator(); i.hasNext(); ) {
			addProduct(i.next());
		}
	}

	public static Product getProductByPosition(int position) {
		return g_stockList.get(position);
	}

	public static Product getProductById(String id) {
		return g_stockMap.get(id);
	}

	public static List<Product> getStockList() {
		return g_stockList;
	}

	public static Map<String, Product> getStockMap() {
		return g_stockMap;
	}
}
